# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from .. import utilities, tables

class WebAclAssociation(pulumi.CustomResource):
    resource_arn: pulumi.Output[str]
    """
    Application Load Balancer ARN to associate with.
    """
    web_acl_id: pulumi.Output[str]
    """
    The ID of the WAF Regional WebACL to create an association.
    """
    def __init__(__self__, __name__, __opts__=None, resource_arn=None, web_acl_id=None):
        """
        Provides a resource to create an association between a WAF Regional WebACL and Application Load Balancer.
        
        -> **Note:** An Application Load Balancer can only be associated with one WAF Regional WebACL.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] resource_arn: Application Load Balancer ARN to associate with.
        :param pulumi.Input[str] web_acl_id: The ID of the WAF Regional WebACL to create an association.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not resource_arn:
            raise TypeError('Missing required property resource_arn')
        __props__['resource_arn'] = resource_arn

        if not web_acl_id:
            raise TypeError('Missing required property web_acl_id')
        __props__['web_acl_id'] = web_acl_id

        super(WebAclAssociation, __self__).__init__(
            'aws:wafregional/webAclAssociation:WebAclAssociation',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

